;;;;
;;;; Function for highlighting directories in a dired listing.
;;;;

;;; by snyder@ricks.enet.dec.com  V1.0 2/1/94.
;;; at some point this could be generalized to highlight executables, etc.

;;; Save this as dired-add.el.  In your .emacs place in the command
;;; (add-hook 'dired-load-hook
;;;      (function
;;;       (lambda ()
;;;	    (load "dired-add"))))


(defvar dired-dir-overlay nil "Overlay List for highlighting directories")
(defvar dired-overlay-list nil "List of file highlighting overlays in this buffer.")
(make-variable-buffer-local 'dired-overlay-list)
(copy-face 'highlight 'dired-directory-face)  ;; Default face for directories, can change
(set-face-foreground  'dired-directory-face "FireBrick")
(defun dired-face-directories ()
  "Highlight all directory files."
  ;; Delete old overlays in this buffer
  (while dired-overlay-list
    (delete-overlay (car dired-overlay-list))
    (setq dired-overlay-list (cdr dired-overlay-list)))
  (setq dired-overlay-list nil)
  
  ;; Make new ones
  (goto-char (point-min))
  (while (re-search-forward dired-re-dir nil t)
    (let ((new-ovl (make-overlay (dired-move-to-filename)
				 (progn (end-of-line) (point)))))
      (overlay-put new-ovl 'face 'dired-directory-face)
      (setq dired-overlay-list (cons new-ovl dired-overlay-list)))
    (forward-line 1)))

(add-hook 'dired-after-readin-hook 'dired-face-directories)

