;;; rsz-message.el --- dynamically resize echo area to fit messages

;;; Copyright (C) 1993 Noah S. Friedman

;;; Author: Noah Friedman <friedman@prep.ai.mit.edu>
;;; Maintainer: friedman@prep.ai.mit.edu
;;; Keywords: extensions, window display
;;; Status: requires GNU Emacs 19.  Kludgy and experimental.

;;; $Id: rsz-message.el,v 1.2 1994/03/31 18:32:20 friedman Exp $

;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2, or (at your option)
;;; any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, you can either send email to this
;;; program's maintainer or write to: The Free Software Foundation,
;;; Inc.; 675 Massachusetts Avenue; Cambridge, MA 02139, USA.

;;; Commentary:

;;; The echo area is one of the more poorly implemented features in Emacs.
;;; It is simply a static array of characters which is copied into by
;;; functions like `message'.  If the message is longer than the allocated
;;; echo area or the frame width, the rest of the message is discarded.

;;; This package implements the echo area on top of the minibuffer instead,
;;; resizing the minibuffer when necessary.  This is not the proper
;;; solution to the problem, but it is a stopgap measure.

;;; There is one serious, unavoidable problem with this implementation.
;;; Because the minibuffer display won't be updated until a sit-for or
;;; sleep-for happens, there is a redefinition of the `message' function
;;; which does this.  Unfortunately, that means that any function which
;;; calls `message' may be interrupted by a process filter, which probably
;;; breaks some important atomicity assumptions.

;;; Also, `message' is sometimes called from C primitives, which means some
;;; messages won't be resized.

;;; Code:

